#!/usr/bin/env python2.7
# -*- coding: utf-8 -*-

from libervia.server.constants import Const as C
from twisted.internet import defer
from twisted.words.protocols.jabber import jid
from sat.tools.common import data_objects

name = u"blog_view"
access = C.PAGES_ACCESS_PUBLIC  # can be a callable
template = u"blog/articles.html"

@defer.inlineCallbacks
def parse_url(self, request):
    try:
        prof_requested = self.nextPath(request)
    except IndexError:
        self.pageError(request)

    template_data = request.template_data

    target_profile = yield self.host.bridge.profileNameGet(prof_requested)
    template_data[u'target_profile'] = target_profile
    target_jid = yield self.host.bridge.asyncGetParamA('JabberID', 'Connection', 'value', profile_key=target_profile)
    target_jid = jid.JID(target_jid).userhost()
    template_data[u'target_jid'] = target_jid


@defer.inlineCallbacks
def prepare_render(self, request):
    target_jid = request.template_data[u'target_jid']
    blog_data = yield self.host.bridge.mbGet(
                          target_jid,
                          "",
                          10,
                          [],
                          {},
                          C.SERVICE_PROFILE)
    request.template_data[u'items'] = data_objects.BlogItems(blog_data)
